extends Node

@export var pion_alb_scene : PackedScene
@export var cadran_negru_scene : PackedScene
@export var cadran_alb_scene : PackedScene

var player : int
var pasi : int
var piesa : int
var board_size : int
var cell_size : int
var grid_pos : Vector2i 
var grid_data : Array # matrice 8 pe 8
var start_pos : Vector2i # retine primul click dat / piesa pe care se doreste a muta
var start_piesa : int
var temp_marker

# Called when the node enters the scene tree for the first time.
func _ready():
	board_size = $Board.texture.get_width()
	# imparte board_size la 8 pentru a obtine dimensiunea fiecarei celule
	cell_size = board_size / 8
	new_game()


# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	pass
	
func _input(event):
	
	if event is InputEventMouseButton :
		if event.button_index == MOUSE_BUTTON_LEFT and event.pressed :
			#verifica daca mouse-ul e pe tabla de joc
			if event.position.x < board_size:
				#convertire pozitie mouse in locatie grid
				grid_pos = Vector2i(event.position / cell_size) # grid_pos memoreza [coloana, linie]
				
				if player == 1 :
					if grid_data[grid_pos.y][grid_pos.x][0] > 0 and pasi == 1 :
						start_piesa = grid_data[grid_pos.y][grid_pos.x][0]
						start_pos = grid_pos
						print("player", player, "a apasat pe chenarul ", grid_pos )
						print("a fost selectata piesa ", start_piesa)
						pasi = 2
						
						
					elif grid_pos != start_pos and pasi == 2:
						print("trece de primul if")
						#marcare noua pozitie a piesei
						grid_data[grid_pos.y][grid_pos.x][0] = start_piesa
						create_marker(6, grid_pos * cell_size + Vector2i(cell_size /2, cell_size /2 + 10 ))
						#demarcare vechea pozitie a piesei
						create_marker(grid_data[start_pos.y][start_pos.x][1], start_pos * cell_size + Vector2i(cell_size /2, cell_size /2+18) )
						grid_data[start_pos.y][start_pos.x][0] = 0
						print(grid_pos)
						print(grid_data)
						pasi = 1
						player = -1
					
						
				elif player == -1 :
					if grid_data[grid_pos.y][grid_pos.x][0] < 0 and pasi == 1 :
						start_piesa = grid_data[grid_pos.y][grid_pos.x][0]
						start_pos = grid_pos
						print("player", player, " a apasat pe chenarul ", grid_pos )
						print("a fost selectata piesa ", start_piesa)
						pasi = 2
						
					elif grid_pos != start_pos and pasi == 2:
						print("trece de primul if")
						#marcare noua pozitie a piesei
						grid_data[grid_pos.y][grid_pos.x][0] = start_piesa
						#demarcare vechea pozitie a piesei
						grid_data[start_pos.y][start_pos.x][0] = 0
						print(grid_pos)
						print(grid_data)
						pasi = 1
						player = 1
						
					
				
					
				
func new_game():
	player = 1
	# [5,1] a doua valoare marcheaza culoarea chenarului tablei de joc, 7 = negru, 8 = alb
	grid_data = [
		[[5,7], [6,8], [0,7], [0,8], [0,7], [0,8], [-6,7], [-5,8]],
		[[4,8], [6,7], [0,8], [0,7], [0,8], [0.7], [-6,8], [-4,7]], 
		[[3,7], [6,8], [0,7], [0,8], [0,7], [0,8], [-6,7], [-3,8]],
		[[1,8], [6,7], [0,8], [0,7], [0,8], [0,7], [-6,8], [-1,7]],
		[2, 6, 0, 0, 0, 0, -6, -2],
		[3, 6, 0, 0, 0, 0, -6, -3],
		[4, 6, 0, 0, 0, 0, -6, -4],
		[5, 6, 0, 0, 0, 0, -6, -5]
		]
	pasi = 1
	create_marker(6, Vector2i(1,0) * cell_size + Vector2i(cell_size /2, cell_size /2 + 10 ))
	create_marker(6, Vector2i(1,1) * cell_size + Vector2i(cell_size /2, cell_size /2 + 10 ))
	create_marker(6, Vector2i(1,2) * cell_size + Vector2i(cell_size /2, cell_size /2 + 10 ))
	create_marker(6, Vector2i(1,3) * cell_size + Vector2i(cell_size /2, cell_size /2 + 10 ))
	create_marker(6, Vector2i(1,4) * cell_size + Vector2i(cell_size /2, cell_size /2 + 10 ))
	create_marker(6, Vector2i(1,5) * cell_size + Vector2i(cell_size /2, cell_size /2 + 10 ))
	create_marker(6, Vector2i(1,6) * cell_size + Vector2i(cell_size /2, cell_size /2 + 10 ))
	create_marker(6, Vector2i(1,7) * cell_size + Vector2i(cell_size /2, cell_size /2 + 10 ))
	
func create_marker(piesa, position) :
	#creaza un marcker node si il adauga ca un child
	if piesa == 6 :
		var pion_alb = pion_alb_scene.instantiate()
		pion_alb.position = position 
		add_child(pion_alb)
	if piesa == 7 :
		var cadran_negru = cadran_negru_scene.instantiate()
		cadran_negru.position = position
		add_child((cadran_negru)) 
	if piesa == 8 :
		var cadran_alb = cadran_alb_scene.instantiate()
		cadran_alb.position = position
		add_child((cadran_alb)) 
